;;;; Common bookmark browser functions:

(define (bookmark-categories bookmark-list)
  (bookmark-categories-iterate bookmark-list '()))

; Selectors:
(define bookmark-title-of (make-selector-function 2))
(define bookmark-url-of (make-selector-function 3))
(define bookmark-category-of (make-selector-function 4))
(define bookmark-comment-of (make-selector-function 5))

(define (bookmark-title-of-non-blank bm)
 (let ((bmt (bookmark-title-of bm)))
   (if (blank-string? bmt) "?" bmt)))

; Constructor
(define (make-bookmark ttl url cat com) (list 'bookmark ttl url cat com))


; Colors

(define bg-color white)
(define text-color black)
(define link-color blue)
(define vlink-color blue)
(define title-color red)

(define body-attributes 
        (list 'bgcolor (rgb-color-encoding bg-color) 'text (rgb-color-encoding text-color)
              'link (rgb-color-encoding link-color) 'vlink (rgb-color-encoding vlink-color)))



; Misc functions

(define (space n)
  (make-list n (char-ref "nbsp")))

;; Return n vertical spaces, i.e., n instances of the p tag.
(define (vertical-space n)
  (if (= n 0) '()
      (div (space 1) (p) (vertical-space (- n 1)))))


(define (br-list lst)
  (map (lambda(el) (list el (br))) lst))

